appModule.controller('artItemController', ['$scope', 'appService', '$state', '$stateParams', '$svDistrict', '$sce', '$compile',
  function($scope, appService, $state, $stateParams, $svDistrict, $sce, $compile) {
    //data
    $scope.stateName = $state.current.name;
    $scope.articleId = $stateParams.id;
    $scope.shareFlag = $stateParams.shareFlag;
    var url = $stateParams.url;
    $scope.articleHtml = $stateParams.favourId || 'artItem';
    $scope.bigImage;  //点击放大图
    $scope.isOpen;
    $scope.article = {};
    /* root enterBefore */
    $scope.$on('changeDistrict', function(e, data) {
      if ($scope.stateName == $state.current.name) {
        $scope.getArticle();
      }
    });
    $scope.$on('$ionicView.beforeLeave', function() {
      $scope.imgsSwipe && $scope.imgsSwipe.destroy(true, true);
    });
    $scope.getArticle = function() {
      $scope.$emit('loading', 'show');
      appService.getData(url, { id: $scope.articleId },
        function(res) {
          $scope.$emit('loading', 'hide');
          article = res.data;
          /* var n200 = item.thumbnail && '200px_' + item.thumbnail;
          item.thum200 = $scope.evalRemotePath(n200); */
          var content = article.content || '';
          /* 处理 富文本 和 图片集 */
          var reg = /<img[^>]*>/gi;
          var images = content.match(reg);
          $scope.article = article;
          content = content && $sce.trustAsHtml(content).$$unwrapTrustedValue(); //过滤
          if (images && images.length) {
            //解析拼接内容
            for (var i = 0; i < images.length; i++) {
              var image = images[i],
                first = image.substr(0, image.indexOf(' ') + 1),
                next = image.substr(image.indexOf(' ')),
                regSrc = /src=[\'\"]?([^\'\"]*)[\'\"]?/i,
                srcStr = image.match(regSrc)[1]
                ;
              if (i == 0) article.pic_name = article.pic_name || srcStr;
              // 将ng-click事件拼接到html中
              var final = first + ' ng-click="showBigImage(' + "'" + srcStr + "'" + ',' + i + ')"' + next;
              //为适应点击图片放大，因此将width和height属性过滤掉
              final = final.replace(/\s+((width)=[\'"]+[0-9]+[\'"]+)/, "").replace(/\s+((height)=[\'"]+[0-9]+[\'"]+)/, "");
              content = content.replace(image, final);
              // var $li = $('<li class="swiper-slide"><div class="article-zoom-img">' + image + '</div></li>');
              var $li = $('<li class="swiper-slide"><div class="swiper-zoom-container">' + image + '</div></li>');
              $('#articleImgs > ul').append($li);
            }
            $scope.imgsSwipe = new Swiper('#articleImgs', { //图片轮播 
              zoom: {
                toggle: false,
              },
              pagination: {
                el: '.swiper-pagination',
                dynamicBullets: true
              },
            });
            content = $compile(content)($scope); //编译
          }
          $('#' + $scope.articleHtml).html(content);
        }, function() {
        }, function() {
        });
    }

    $scope.showBigImage = function(imgSrcPath, i) {
      $scope.imgsSwipe.slideTo(i, 0, false);
      $('#articleImgs').show();
      if (!$scope.isUpdateSize) { $scope.imgsSwipe.update(); $scope.isUpdateSize = true; }
      console.log(i)
    };
    $scope.hideBigImage = function() {
      $scope.imgsSwipe.zoom.out();
      $('#articleImgs').hide();
    };
  }
])
