appModule.controller('cv19qaController', ['$scope', '$rootScope', 'appService', '$timeout', '$state', '$ionicPopup', '$ionicScrollDelegate', '$ionicModal', function($scope, $rootScope, appService, $timeout, $state, $ionicPopup, $ionicScrollDelegate, $ionicModal) {
  /* datas */
  $scope.stateName = $state.current.name;
  $scope.region //用户所选社区
  $scope.select = {};
  $scope.regionArr = [];
  /* 区 */
  $scope.select.area = {
    value: '请选择', options: [],
    selecOption: function(type) {
      this.value = type.name;
      $scope.regionArr[0] = type;
      $scope.selectBlur();
      $scope.select.street.value = '请选择'
      $scope.select.community.value = '请选择'
      $scope.select.street.options = []
      $scope.select.community.options = []
      $scope.tempRegion = null
      if (!type.children) {
        $scope.getStreet(type.id)
        return
      }
      $scope.select.street.options = type.children
    },
    onFocus: function() {
      this.showOptions = !this.showOptions;
    },
    options: [
    ]
  };
  /* 街道 */
  $scope.select.street = {
    value: '请选择', options: [],
    selecOption: function(type) {
      this.value = type.name;
      $scope.regionArr[1] = type;
      $scope.selectBlur();
      $scope.select.community.value = '请选择'
      $scope.select.community.options = type.children
      if (!type.children.length) $scope.tempRegion = type
    },
    onFocus: function() {
      this.showOptions = !this.showOptions;
    },
    options: [
    ]
  };
  /* 社区 */
  $scope.select.community = {
    value: '请先选择街道', options: [],
    selecOption: function(type) {
      // console.log(type)
      this.value = type.name;
      $scope.regionArr[2] = type;
      $scope.tempRegion = type;
      $scope.selectBlur();
    },
    onFocus: function() {
      this.showOptions = !this.showOptions;
    },
    options: [
    ]
  };
  $scope.selectBlur = function() {
    $scope.select.area.showOptions = false
    $scope.select.street.showOptions = false
    $scope.select.community.showOptions = false
  }
  $scope.selectClear = function() {
    $scope.select.area.value = '请选择'
    $scope.select.street.value = '请选择'
    $scope.select.community.value = '请选择'
    $scope.tempRegion = null
  }
  /* 选择社区确认 */
  $scope.changeRegion = function() {
    if (!$scope.tempRegion) {
      $scope.alert('请选择您所在社区')
      return
    }
    $scope.region = $scope.tempRegion
  }
  $scope.clearRegion = function() {
    $scope.region = null
    $scope.doRefresh()
  }
  $scope.$on('$ionicView.loaded', function() {
    if (!$scope.user.pgmRid) $scope.$emit("updateUserInfo");
    $scope.getArea(2205) // 街道列表
  });
  $scope.$on('$ionicView.enter', function() {
    if (!$scope.user.pgmRid) $scope.goState('pgmRelation', null, null, 'none');
    else $scope.doRefresh()
  });
  $scope.$on('updatedUser', function(e) {
    if (!$scope.user.pgmRid) {
      $scope.goState('pgmRelation', null, null, 'none')
      return
    }
    $scope.clearRegion()
  });
  $scope.getArea = function(code) {
    $scope.$emit('loading', 'show');
    // { code: $scope.publicCityId, midArr: '0', state: 1 }
    var param = {
      midArr: '0', state: 1, code: code
    }
    appService.get(urlMap.region, param, function(res) {
      $scope.$emit('loading', 'hide');
      if (res.data[0]) {
        $scope.select.area.options = res.data[0].children
      }
    })
  }
  $scope.getStreet = function(pid) {
    $scope.$emit('loading', 'show');
    var param = {
      midArr: '0', state: 1
    }
    param.pid = pid
    appService.get(urlMap.region, param, function(res) {
      $scope.$emit('loading', 'hide');
      if (res.data) {
        $scope.select.street.options = res.data
      }
    })
  }
  $scope.getQ = function(page) {
    appService.getData(urlMap.qaGetquestions, { userId: $scope.user.id, regionCode: $scope.region.code, page: page }, function(res) {
      $scope.$emit('loading', 'hide');
      if (res.code == 200) {
        $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
        $scope.domore = false;
        if (page < 1) {
          $scope.questions = []
        }
        var list = res.data, length = list.length, size = res.size;
        if (length >= size) $timeout(function() {
          $scope.domore = true;
        }, 500)
        $scope.questions = $scope.questions.concat(list);
        return
      }
      $scope.alert(res.msg)
    })
  }
  $scope.doRefresh = function() {
    $scope.$broadcast('scroll.refreshComplete'); //上拉刷新结束
    $scope.questions = null
    $scope.domore = true
    $scope.page = 0
    $timeout(function() {
      $ionicScrollDelegate.scrollTop()
    })
  }
  $scope.onInfinite = function() {
    $scope.getQ($scope.page++)
  }
  $scope.goQa = function(item) {
    if (item.questionState == "是" || item.questionState == "否") return
    $scope.goState('cv19qaform', { questions: item, regionArr: $scope.regionArr })
  }
}
]);
