appModule.controller('thxLianluozhanMsgController', ['$scope', '$ionicPopup', '$stateParams', 'appService', '$state', '$timeout', '$ionicScrollDelegate', '$sce', function($scope, $ionicPopup, $stateParams, appService, $state, $timeout, $ionicScrollDelegate, $sce) {
    $scope.stateName = $state.current.name;
    $scope.msgList;
    $scope.placeholder = '';
    $rootScopeViewGoback = $scope.viewGoback;
    $scope.tabIndex = 0
    $scope.domore = true
    $scope.pageNext = 0
    $scope.llz // selected llz obj
    $scope.selectedRegion  // selected l4 obj
    $scope.form = {
    };
    $scope.$on('$ionicView.loaded', function() {
        $scope.getStreet()
    });
    $scope.navs = [
        { name: '反馈心声' },
        { name: '我的心声' }
    ];
    $scope.changeTab = function(i) {
        $scope.tabIndex = i;
        $ionicScrollDelegate.scrollTop();
        $scope.domore = true
        $scope.pageNext = 0
    }
    $scope.onInfinite = function() {
        $scope.getMyMsg($scope.pageNext++)
    }
    /* 我的留言 */
    $scope.getMyMsg = function(page) {
        var data = {
            userId: $scope.user.id,
            size: 10,
            page: page
        }
        appService.get(urlMap.jiweiLLZMsg + '/app', data, function(res) {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            if (!res || !res.data) return;
            if (page < 1) $scope.myMsg = []
            var list = res.data, length = list.length, size = res.size || 10;
            if (length < size) $scope.domore = false;
            else {
                $timeout(function() {
                    $scope.domore = true;
                }, 200)
            }
            res.data.forEach(function(item) {
                item.title = item.title || item.content.slice(0, 30);
            })
            $scope.myMsg = $scope.myMsg.concat(res.data)
        })
    }
    /* 联络站所属地 */
    $scope.getStreet = function() {
        appService.get(urlMap.region, { pid: 5, state: 1, mid: 1 }, function(res) {
            if (res.data) {
                $scope.regionLevel4 = res.data
            }
        })
    }
    /* 弃用社区选择, 改为从街道获取联络站 */
    /* $scope.getCommunity = function(selectedRegion) {
        $scope.regionLevel5 = []
        appService.get(urlMap.region, { pid: selectedRegion.id, state: 1, mid: 1 }, function(res) {
            if (res.data) {
                $scope.regionLevel5 = res.data
            }
        })
    } */

    /* 联络站列表 */
    $scope.getLLz = function(selectedRegion) {
        $scope.llzlist = null;
        var code = selectedRegion.code
        var data = {
            regionCode: code,
            size: 999,
            page: 0
        }
        appService.get(urlMap.jiweiLLZ + '/app', data, function(res) {
            $scope.llzlist = res.data;
        });
    }
    /* 社区变化 */
    $scope.changeSelectLianluozhan = function(llz) {
        $scope.form.lsId = llz.id
    }
    $scope.submit = function() {
        if (!$scope.form.lsId) {
            $scope.alert("请选择联络站");
            return;
        }
        if (!$scope.form.title) {
            $scope.alert("请填写简要内容");
            return;
        }
        if (!$scope.form.content) {
            $scope.alert("请详述内容");
            return;
        }
        if ($scope.form.content.length > 1100) {
            $scope.alert("内容不能超过1000字！");
            return;
        }
        var msg = $scope.form.phone ? $scope.ruleAll() : true
        if (msg != true) {
            $scope.alert(msg);
            return;
        }
        $ionicPopup.confirm({
            // title: '填报成功',
            template: '您是否确认提供的信息真实有效？',
            cancelText: '取消',
            okText: '确认并提交'
        }).then(function(res) {
            if (res) {
                $scope.$emit('loading', 'show');
                var file = $('#localPhotoFile').val() || ($scope.cameraFile && $scope.cameraFile.name) || '';
                $scope.fileType = $scope.thisfileType(file);
                if (!$scope.fileType == 'error') {
                    return;
                }
                /* 拍摄上传 */
                if ($scope.cameraFile) {
                    var file = $scope.cameraFile;
                    var params = {};
                    params.httpPath = $scope.httpPath;
                    params.type = $scope.fileType;
                    params.maxWidth = $scope.maxWidth;
                    var ft = new FileTransfer();
                    var options = new FileUploadOptions();
                    options.fileKey = "file";
                    options.mimeType = "multipart/form-data";
                    options.fileName = file.name;
                    options.params = params;
                    //传输进度  
                    ft.onprogress = function(progressEvent) {
                    };
                    ft.upload(file.fullPath, urlMap.fileUpload,
                        function(res) {
                            if (res.response) res = JSON.parse(res.response)
                            var imgUrl = res.imgUrl || res.vioUrl;
                            if (imgUrl) {
                                $scope.postForm(imgUrl)
                            } else {
                                $scope.$emit('loading', 'hide');
                                $scope.alert("文件上传失败，请联系客服人员！");
                            }
                        },
                        function() {
                            $scope.alert("媒体上传失败，请联系客服人员！");
                        },
                        options);
                    return;
                }
                /* 没有附件 */
                if (!$scope.fileType) {
                    $scope.postForm();
                    return
                }
                /* 本地文件上传 */
                $timeout(function() {
                    $("#files").ajaxSubmit({
                        url: urlMap.fileUpload,
                        type: "post",
                        dataType: "json",
                        success: function(res) {
                            var imgUrl = res.imgUrl || res.vioUrl;
                            if (imgUrl) {
                                $scope.postForm(imgUrl)
                            } else {
                                $scope.alert("文件上传失败，请联系客服人员！");
                            }
                        },
                        error: function(xhr) {
                            $scope.$emit('loading', 'hide');
                            $scope.alert("媒体上传失败，请联系客服人员！");
                        },
                        beforeSerialize: function() {
                        },
                        beforeSend: function() {
                            //$("#progressNumber").html('0%');
                        },
                        uploadProgress: function(event, position, total, percentComplete) {
                        }
                    });
                })
            } else {
                console.log('返回！');
            }
        });
    }
    /***
     * 提交表单
     */
    $scope.postForm = function(fileStr) {
        $scope.form.file = fileStr
        $scope.form.regionCode = $scope.publicCityId
        $scope.form.userId = $scope.user.id
        console.log($scope.form)
        var data = $scope.form;
        appService.postData(urlMap.jiweiLLZMsg, data,
            function(results) {
                $scope.$emit('loading', 'hide');
                if (!results)
                    $scope.alert("提交出错，请联系客服人员！");
                else {
                    // $.get(urlMap.sendMessageForReportInfo, { areaID: $scope.publicCityId });
                    $scope.alert("感谢您，信息提交成功，请耐心等待审核！", null, function() {
                        $scope.init()
                    });
                }
            })
    }
    $scope.init = function() {
        var lsId=$scope.form.lsId
        $scope.form = {
            lsId:lsId
        }
        $scope.removeFile()
    }
    /* 
    *** 附件处理 
    */
    $scope.removeFile = function(reset) {
        $scope.showUploadFiles = []; //预览
        $scope.showUploadNames = []; //预览失败 显示文件名
        if (!reset) {
            $('#localPhotoFile').val(''); //本地
            $scope.cameraFile = null; //拍摄
        }
    }
    /* 本地附件读取 */
    function readerfile(file) {
        return new Promise(function(resolve, reject) {
            var reader = new FileReader();
            reader.onload = function() {
                resolve(reader.result);
            };
            if (file) {
                reader.readAsDataURL(file)
            }
        })
    }
    $scope.fileChangeEvent = function() {
        var files = $('#localPhotoFile')[0].files;
        for (var i = 0; i < files.length; i++) {
            $scope.fileType = $scope.thisfileType(files[i].name);
            if ($scope.fileType == 'error') {
                $scope.alert('上传文件格式有误')
                return;
            }
            if (files[i].size > 100 * 1024 * 1024) {
                $scope.alert('文件体积过大, 最大为100M')
                return;
            }
            $scope.removeFile('reset');
            try {
                readerfile(files[i]).then(function(e) {
                    $scope.$apply(function() {
                        if ($scope.fileType == 2) {
                            $scope.showUploadFiles.push($sce.trustAsResourceUrl(e))
                        }
                        else $scope.showUploadFiles.push(e)
                    })
                })
            } catch (e) {
                alert(e);
                $scope.$apply(function() {
                    $scope.showUploadNames.push(files);
                })
            }
        }
    }
    /***
     * use camera
     */
    $scope.useCamera = function(type) {
        //开始录像(最长录制时间:60秒)
        if (type == 1) navigator.device.capture.captureImage(success, onError, { limit: 1 });
        if (type == 2) navigator.device.capture.captureVideo(success, onError);
        function success(mediaFiles) {
            $scope.showUploadFiles = [];
            for (var i = 0; i < mediaFiles.length; i++) {
                var name = mediaFiles[i].name;
                var path = mediaFiles[i].fullPath;
                $scope.fileType = $scope.thisfileType(name);
                if (!$scope.fileType == 'error') {
                    return;
                }
                $scope.removeFile('reset');
                $scope.$apply(function() {
                    if ($scope.fileType == 2) {
                        $scope.showUploadFiles.push($sce.trustAsResourceUrl(path))
                    }
                    else
                        $scope.showUploadFiles.push(path)
                })
                $scope.cameraFile = mediaFiles[i];
            }
        }
        //录制失败
        function onError(error) {
            // $scope.alert('未进行拍摄！错误码:' + error.code);
        }
    }
}
]);
