appModule.controller('LeaveMsgDetailController', ['$rootScope', '$scope', '$stateParams', 'appService', '$sce', '$timeout', '$compile', function($rootScope, $scope, $stateParams, appService, $sce, $timeout, $compile) {
  var url = urlMap[$stateParams.queryUrl] || urlMap.getMsgById;
  $scope.detailId = $stateParams.id;
  $scope.readType = $stateParams.readType;
  $scope.isMy = $stateParams.isMy;
  $scope.domore = true;
  $scope.replyHtml = 'msg' + $scope.detailId;
  $scope.$on('$ionicView.enter', function() {
    // $scope.getMsgDetail();
  });
  $scope.$on('$ionicView.leave', function() {
    $rootScope.viewGoback = $rootScopeViewGoback
  });
  function formatPhone(str) {
    if (!str) return str
    var html = '',
      mobileReg = /^(\(\d{3,4}\)|\d{3,4}\s*[-——－]{1,3}\s*|0\d{2,3})\d+$/,
      telhtml,
      matched
      ;
    telhtml = str.replace(/(电话[:：]?\s*)?(((\(\d{3,4}\)|\d{3,4}\s*[-——－]{1,3}\s*|0\d{2,3})\d+)|(\d{3,}))/g, function(word) {
      if (/(电话[:：]?\s?)/.test(word)) {
        matched = true;
        return word.replace(/\d.*\d$/, '<a class="f18" href="tel:$&">$&</a> ');
      }
      if (mobileReg.test(word)) {
        matched = true;
        return word.replace(mobileReg, '<a class="f18" href="tel:$&">$&</a> ');
      }
      if (/^((953\d{2})|(955\d{2})|(123\d{2})|(400\d{7}))$/.test(word)) {
        matched = true;
        return word.replace(/\d.*\d$/, '<a class="f18" href="tel:$&">$&</a> ');
      }
      if (/^\d{7,}$/.test(word)) {
        matched = true;
        return '<a class="f18" href="tel:' + word + '">' + word + '</a> ';
      }
      return word;
    });
    /* if (!matched && /\d+/.test(str)) telhtml = '<a href="tel:' + str + '">' + str + '</a>';
    telhtml = telhtml.replace(/\w{1,2}\s{0,1}\u3001/g, 'splitflag$&'); //1、
    var list = telhtml.split('splitflag'); //1、
    for (var i = 0; i < list.length; i++) {
      if (!list[i]) continue;
      html += '<p class="mb8">' + list[i] + '</p>';
    } */
    return telhtml;
  }
  $scope.getMsgDetail = function() {
    // $scope.$emit('loading', 'show');
    appService.getData(url, { id: $scope.detailId }, function(jsonData) {
      // $scope.$emit('loading', 'hide');
      $scope.$broadcast('scroll.infiniteScrollComplete'); //懒加载更多结束
      $scope.domore = false
      var portrait = jsonData.portrait;
      if (portrait != null && portrait != '') {
        jsonData.portrait = $scope.pic + '/' + portrait;
      } else {
        jsonData.portrait = $scope.pic + urlMap.defaultImg;
      }
      jsonData.replyContent = formatPhone(jsonData.replyContent);
      // jsonData.stateName = jsonData.state == 0?'审核中'
      $scope.msgItem = jsonData;
      /* 留言附件 */
      $scope.msgItem.imgJson200 = []
      $scope.msgItem.imgListArr900 = []
      $scope.msgItem.vioListArr = []
      var resources = $scope.msgItem.resources
      resources.forEach(function(item) {
        if (item.type === 1) {
          item.img200 = $scope.evalRemotePath('200px_' + item.url)
          $scope.msgItem.imgJson200.push(item)
          $scope.msgItem.imgListArr900.push($scope.evalRemotePath('900px_' + item.url))
        }
        if (item.type === 2) {
          item.vio = $sce.trustAsResourceUrl($scope.evalRemotePath(item.url, $scope.vio))
          $scope.msgItem.vioListArr.push(item)
        }
      })
      if ($scope.msgItem.imgJson200.length) {
        $timeout(function() {
          $scope.imgsSwipe = new Swiper('#articleImgs', { //图片轮播 
            zoom: {
              toggle: false,
            },
            pagination: {
              el: '.swiper-pagination',
              dynamicBullets: true
            },
          });
        })
      }
      // article.replyContent = $sce.trustAsHtml(article.replyContent).$$unwrapTrustedValue();
      /* 富文本回复处理 */
      content = $scope.msgItem.replyResources && $sce.trustAsHtml($scope.msgItem.replyResources).$$unwrapTrustedValue();
      //找到<img标签
      var reg = /<img[^>]*>/gi;
      // 匹配出html中的src属性
      var images = content.match(reg);
      //包含图片
      if (images && images.length) {
        //解析拼接内容
        for (var i = 0; i < images.length; i++) {
          var image = images[i],
            first = image.substr(0, image.indexOf(' ') + 1),
            next = image.substr(image.indexOf(' ')),
            regSrc = /src=[\'\"]?([^\'\"]*)[\'\"]?/i,
            srcStr = image.match(regSrc)[1]
            ;
          // 将ng-click事件拼接到html中
          var final = first + ' ng-click="showReplyImage(' + i + ')"' + next;
          //为适应点击图片放大，因此将width和height属性过滤掉
          final = final.replace(/\s+((width)=[\'"]+[0-9]+[\'"]+)/, "").replace(/\s+((height)=[\'"]+[0-9]+[\'"]+)/, "");
          content = content.replace(image, final);
          var $li = $('<li class="swiper-slide"><div class="swiper-zoom-container">' + image + '</div></li>');
          $('#replyResouces > ul').append($li);
        }
        $timeout(function() {
          $scope.replyimgSwiper = new Swiper('#replyResouces', { //图片轮播 
            zoom: {
              toggle: false,
            },
            pagination: {
              el: '.swiper-pagination',
              dynamicBullets: true
            },
          });
        })
        content = $compile(content)($scope); //编译
      }
      $('#' + $scope.replyHtml).html(content);
      /* 已读更新通知 */
      if ($scope.readType == 0) {
        $scope.userMsgCountFn(--$scope.userMsgCount);
      }
    });
  };
  $scope.showMsgImage = function(i) {
    $scope.showMsgImageSwiper = true
    $scope.imgsSwipe.slideTo(i, 0, false);
    $('#articleImgs').show();
    $scope.imgsSwipe.update();
  };
  $scope.hideMsgImage = function() {
    $scope.showMsgImageSwiper = false
    $scope.imgsSwipe && $scope.imgsSwipe.zoom.out();
    $('#articleImgs').hide();
  };
  /* 回复图片预览 */
  $scope.showReplyImage = function(i) {
    $scope.showReplyImageSwiper = true
    $scope.replyimgSwiper.slideTo(i, 0, false);
    $('#replyResouces').show();
    $scope.replyimgSwiper.update();
  };
  $scope.hideReplyImage = function() {
    $scope.showReplyImageSwiper = false
    $scope.replyimgSwiper && $scope.replyimgSwiper.zoom.out();
    $('#replyResouces').hide();
  };
  $rootScopeViewGoback = $rootScope.viewGoback;
  $rootScope.viewGoback = function() {
    if ($scope.showMsgImageSwiper) {
      $scope.hideMsgImage();
      return
    }
    if ($scope.showReplyImageSwiper) {
      $scope.hideReplyImage()
      return
    }
    $rootScopeViewGoback()
  }
  $scope.vioFocus = function() {
    $('video').focus()
  }
  $scope.onInfinite = function() {
    $scope.getMsgDetail();
  };
},
]);
