
appModule.controller('zhzzArticleDetailController', ['$scope', '$state', 'appService', '$stateParams', '$sce', '$compile',
  function ($scope, $state, appService, $stateParams, $sce, $compile) {
    //data
    $scope.queryUrl = $stateParams.queryUrl;
    $scope.stateName = $state.current.name;
    $scope.articleId = $stateParams.id;
    $scope.pageType = $stateParams.type;
    $scope.shareFlag = $stateParams.shareFlag;
    $scope.articleInfo = {};
    var url = urlMap[$scope.queryUrl];
    $scope.articleHtml = $scope.favourId = $scope.queryUrl + $scope.articleId;
    $scope.bigImage;  //点击放大图
    $scope.isUpdateSize;
    /* root enterBefore */
    $scope.$on('changeDistrict', function (e, data) {
      if ($scope.stateName == $state.current.name) {
        $scope.getArticle();
      }
    });
    $scope.$on('$ionicView.beforeLeave', function () {
      $scope.imgsSwipe && $scope.imgsSwipe.destroy(true, true);
    });
    $scope.getArticle = function () {
      $scope.$emit('loading', 'show');
      var data = {
        mid: 1,
        id: $scope.articleId
      }
      appService.getData(url, data,
        function (results) {
          $scope.$emit('loading', 'hide');
          article = (results.data && results.data[0]) || results.data;
          console.log(article);
          var content = article.textContent || article.content || article.details;
          //找到<img标签
          var reg = /<img[^>]*>/gi;
          // 匹配出html中的src属性
          var images = content && content.match(reg);
          $scope.articleInfo = article;
          content = content && $sce.trustAsHtml(content).$$unwrapTrustedValue(); //过滤
          //包含图片
          if (images && images.length) {
            //解析拼接内容
            for (var i = 0; i < images.length; i++) {
              var image = images[i],
                first = image.substr(0, image.indexOf(' ') + 1),
                next = image.substr(image.indexOf(' ')),
                regSrc = /src=[\'\"]?([^\'\"]*)[\'\"]?/i,
                srcStr =image.match(regSrc)[1]
                ;
              // if (i == 0) article.pic_name = article.pic_name || srcStr;
              // 将ng-click事件拼接到html中
              var final = first + ' ng-click="showBigImage(' + "'" + srcStr + "'" + ',' + i + ')"' + next;
              //为适应点击图片放大，因此将width和height属性过滤掉
              final = final.replace(/\s+((width)=[\'"]+[0-9]+[\'"]+)/, "").replace(/\s+((height)=[\'"]+[0-9]+[\'"]+)/, "");
              content = content.replace(image, final);
              // var $li = $('<li class="swiper-slide"><div class="article-zoom-img">' + image + '</div></li>');
              var $li = $('<li class="swiper-slide"><div class="swiper-zoom-container">' + image + '</div></li>');
              $('#articleImgs > ul').append($li);
            }
            $scope.imgsSwipe = new Swiper('#articleImgs', { //图片轮播 
              zoom: {
                toggle: false,
              },
              pagination: {
                el: '.swiper-pagination',
                dynamicBullets: true
              },
            });
            content = $compile(content)($scope); //编译
          }
          $('#' + $scope.articleHtml).html(content);
        }, function () {
        }, function () {
        });
    }
    $scope.showBigImage = function (imgSrcPath, i) {
      $scope.imgsSwipe.slideTo(i, 0, false);
      $('#articleImgs').show();
      if (!$scope.isUpdateSize) { $scope.imgsSwipe.update(); $scope.isUpdateSize = true; }
      console.log(i)
    };
    $scope.hideBigImage = function () {
      $scope.imgsSwipe.zoom.out();
      $('#articleImgs').hide();
    };
  }
]);
